#include "StdAfx.h"
#include "CallHistoryDlg.h"
#include "CallHistoryActorEvent.h"

CCallHistoryActorEvent::CCallHistoryActorEvent(CCallHistoryDlg *pDlg)
	: m_pCallHistoryDlg(pDlg)
{
	// Set observer
	//g_pMessengerActor->RegisterObserver(this);
	IGTWASActor *pWASActor = g_pMessengerActor->GetWASActor();
	pWASActor->RegisterObserver(this);

	m_tridList.clear();
}

CCallHistoryActorEvent::~CCallHistoryActorEvent(void)
{
	g_pMessengerActor->GetWASActor()->UnRegisterObserver(this);	
	//g_pMessengerActor->UnRegisterObserver(this);
}

void CCallHistoryActorEvent::RequestCallHistory(NTCallType eCallType)
{
	IGTWASActor *pWASActor = g_pMessengerActor->GetWASActor();
	trid_t trid;
	
	if (pWASActor->RequestCallHistory(eCallType, GetLanguageStringUnicode(), &trid))
	{
		m_tridList.push_back(trid);
	}
	else
	{
		//ASSERT(FALSE);
	}
}

bool CCallHistoryActorEvent::OnGTWASActor_ResponseCallHistory( IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const std::vector<NE_CALL_DATA> &list )
{
	//   trid  ƴϸ true Ͽ   óϵ ش.
	std::list<trid_t>::iterator findTrid = std::find(m_tridList.begin(), m_tridList.end(), trid);
	if (findTrid == m_tridList.end())
		return true;

	if (eErrorCode != wasError_None)
		return false;

	m_tridList.remove(*findTrid);

	m_pCallHistoryDlg->SetCallHistoryData(list);

	return false;
}

void CCallHistoryActorEvent::RequestSetCallMemo( int nCallSeq, CString strMemo )
{
	IGTWASActor *pWASActor = g_pMessengerActor->GetWASActor();
	trid_t trid;

	if (pWASActor->RequestSetCallMemo(nCallSeq, strMemo, &trid))
	{
		m_tridList.push_back(trid);
	}
	else
	{
		//ASSERT(FALSE);
	}
}

bool CCallHistoryActorEvent::OnGTWASActor_ResponseSetCallMemo( IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, int nCallSeq )
{
	//   trid  ƴϸ true Ͽ   óϵ ش.
	std::list<trid_t>::iterator findTrid = std::find(m_tridList.begin(), m_tridList.end(), trid);
	if (findTrid == m_tridList.end())
		return true;

	if (eErrorCode != wasError_None)
		return false;

	m_tridList.remove(*findTrid);

	m_pCallHistoryDlg->UpdateMemo(nCallSeq);

	return false;
}

void CCallHistoryActorEvent::RequestSearchCallHistory(NTCallType eCallType, CString strSearchWord)
{
	IGTWASActor *pWASActor = g_pMessengerActor->GetWASActor();
	trid_t trid;

	if (pWASActor->RequestSearchCallHistory(eCallType, strSearchWord, GetLanguageStringUnicode(), &trid))
	{
		m_tridList.push_back(trid);
	}
	else
	{
		//ASSERT(FALSE);
	}

}

bool CCallHistoryActorEvent::OnGTWASActor_ResponseSearchCallHistory( IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const std::vector<NE_CALL_DATA> &list )
{
	//   trid  ƴϸ true Ͽ   óϵ ش.
	std::list<trid_t>::iterator findTrid = std::find(m_tridList.begin(), m_tridList.end(), trid);
	if (findTrid == m_tridList.end())
		return true;

	if (eErrorCode != wasError_None)
		return false;

	m_tridList.remove(*findTrid);

	m_pCallHistoryDlg->SetCallHistoryData(list);

	return false;
}
